#!/bin/awk -f

# Projekce pohybu Slunce (vystup sunah.f) do horizontalni roviny.
# Miroslav Broz (miroslav.broz@email.cz), Aug 27th 2002

BEGIN{
  IN = ARGV[1];
  OUT_NODUS = "nodus.dat";
  OUT_LABEL = "labels.plt";

  pi = 3.1415926535;
  deg = pi/180;

  print "# hour & x [cm] & y [cm]"

}
(FILENAME == IN) && /zempisn ka/{
  phi = dms($1);
}
(FILENAME == IN) && /vzdlenost prmtu nodu/{
  y_nodus = -$1;
  z_nodus = -y_nodus*tg(phi);
  print 0, 0 >OUT_NODUS;
  print 0, y_nodus >OUT_NODUS;
  print "set label \" P\" at 0,0 left" >OUT_LABEL;
  print "set label \" N\" at " 0 "," y_nodus " left" >OUT_LABEL;
}
!/^#/ && (FILENAME != IN){

  a = $8*deg;
  h = $9*deg;

  D_nodus = z_nodus/tg(h);
  x = -D_nodus * sin(a);
  y = y_nodus - D_nodus * cos(a);

  if (h > 0) {
    print $5, x, y;
    print "set label \"" $5 "  \" at " x "," y " right rotate font \"Helvetica,8\"" >OUT_LABEL;
  }
}

########################################################################

func dms(s) {
  split(s, l, /:/);
 
  return (sign(s)*(abs(l[1])+l[2]/60+l[3]/3600)*pi/180);
}

func sign(s) {
  if (substr(s,0,1) == "-")
    return -1;
  else
    return 1;
}

func abs(x) {
  if (x > 0)
    return x;
  else if (x < 0)
    return -x;
  else
    return 0;
}

func tg(x) {
  return (sin(x)/cos(x));
}

